/*
 * my_defines.h
 *
 *  Created on: 11 de mar de 2023
 *      Author: arne
 */

#ifndef MY_DEFINES_H_
#define MY_DEFINES_H_

//*******************************************************************************
// Definições gerais do módulo
//*******************************************************************************
#define TRUE 			1
#define FALSE 			0
#define CR				0x0D
#define LF				0x0A
#define ACK				0x06

//*******************************************************************************
// Definições para uso do debug
//*******************************************************************************
//#define __DEBUG__		// comentar para modo normal (envio binário)

//*******************************************************************************
// Definições para uso das USARTs
//*******************************************************************************
//#define __USE_USART1__
//#define __USE_USART2__
#define __USE_USART3__

//*******************************************************************************
// Definições para uso do protocolo
//*******************************************************************************
#define HEADER			'@'				// header do protocolo
#define NR_DISP			0x03			// nr do dispositivo na rede!

#define POSHEADER		0x00			// posições e tamanho final do buffer
#define POSDISPS		0x01
#define POSQTBYTES		0x02
#define POSDATA			0x03

#define TAMDATA			0x0E			// apenas 14 bytes - LCD
#define TAMBUF			(0x03 + TAMDATA + 0x01)

//*******************************************************************************
// Outras definição importantes para o módulo
//*******************************************************************************
//I/O's
//LED's
#define PORTLED			GPIOC
#define LED_Live		GPIO_Pin_13
#define setLED_Live		GPIO_SetBits(PORTLED, LED_Live)
#define resLED_Live     GPIO_ResetBits(PORTLED, LED_Live)

#define PORTLED2		GPIOB
#define LED1			GPIO_Pin_5
#define LED2			GPIO_Pin_6
#define LED3			GPIO_Pin_7
#define LED4			GPIO_Pin_8
#define setLED1			GPIO_SetBits(PORTLED2, LED1)
#define resLED1     	GPIO_ResetBits(PORTLED2, LED1)
#define setLED2			GPIO_SetBits(PORTLED2, LED2)
#define resLED2     	GPIO_ResetBits(PORTLED2, LED2)
#define setLED3			GPIO_SetBits(PORTLED2, LED3)
#define resLED3     	GPIO_ResetBits(PORTLED2, LED3)
#define setLED4			GPIO_SetBits(PORTLED2, LED4)
#define resLED4     	GPIO_ResetBits(PORTLED2, LED4)

//BTN's
#define PORTBTN			GPIOA
#define BTN1			GPIO_Pin_8
#define BTN4			GPIO_Pin_9
#define BTN7			GPIO_Pin_10
#define readBTN1		(GPIO_ReadInputDataBit(PORTBTN, BTN1))
#define readBTN4		(GPIO_ReadInputDataBit(PORTBTN, BTN4))
#define readBTN7		(GPIO_ReadInputDataBit(PORTBTN, BTN7))


#define TIME2s			0x08
#define TIME3s			0x0C
#define TIMELED			0x02

#endif /* MY_DEFINES_H_ */
