/*
 * usart_STM.h
 *
 *  Created on: 24 de set de 2018
 *      Author: arne_
 *
 *  Contém funções de controle da USART
 *  linha STM32F103
 *
 *  Desenvolvido por Eng. Márcio José Soares
 */

#ifndef USART_STM_H_
#define USART_STM_H_

#ifdef __cplusplus
extern "C" {
#endif

//******************************************************************************
// Arquivos incluídos no módulo
//******************************************************************************
#include "stm32f10x.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_gpio.h"
#include <stm32f10x_usart.h>
#include <string.h>

//#define __USE_USART3__
#include "my_defines.h"
#include "delay.h"
#include "ring_comm.h"

//******************************************************************************
// Declara variáveis externas do módulo
//******************************************************************************
#ifdef __DEBUG_RS232__
extern uint8_t mlow;
extern uint8_t mhigh;
extern byte temp_debug_ja_mostrou;
#endif

//******************************************************************************
// Declara funções externas do módulo
//******************************************************************************

//******************************************************************************
// Declara funções do módulo
//******************************************************************************
#ifdef __USE_USART1__
void usart1_init(void);
unsigned char usart1_ReadByteSync(USART_TypeDef *USARTx);
void USART1_IRQHandler(void);
void usart1_buf_send(const unsigned char pucBuffer[], unsigned long ulCount);
void usart1_buf_sendR(char pucBuffer[]);
void usart1_putchar(char data);
#endif

#ifdef __USE_USART2__
void usart2_init(void);
unsigned char usart2_ReadByteSync(USART_TypeDef *USARTx);
void USART2_IRQHandler(void);
void usart2_buf_send(const unsigned char pucBuffer[], unsigned long ulCount);
void usart2_buf_sendR(char pucBuffer[]);
void usart2_putchar(char data);
#endif

#ifdef __USE_USART3__
void usart3_init(void);
unsigned char usart3_ReadByteSync(USART_TypeDef *USARTx);
void USART3_IRQHandler(void);
void usart3_buf_send(const unsigned char pucBuffer[], unsigned long ulCount);
void usart3_buf_sendR(char pucBuffer[]);
void usart3_putchar(char data);
#endif


#ifdef __cplusplus
}
#endif

#endif /* USART_STM_H_ */
