//********************************************************************************
// Mdulo de funes auxiliares para depurao
//
// Desenvolvido por Mrcio Jos Soares - 07/02/2008
//
// Microcontrolador: AVR (original)
// Compilador: GCC AVR - AVRStudio 7.0 - Windows
//
// ltima alterao: 02/10/2018
//	- Adaptado arquivo para rodar com compilador OpenSTM32 (plataforma ARM)
//********************************************************************************

//********************************************************************************
// Arquivos includos no mdulo
//********************************************************************************
#include "aux_dep.h"

//********************************************************************************
// Definies genricas de todos os mdulos
//********************************************************************************

//********************************************************************************
// Funes do mdulo
//********************************************************************************

//**********************************************************************
// Funo init_crcccitt_tab - inicia tabela de calculo CRCCCITT
//
// Entradas - nenhuma
// Sadas   - nenhuma
//**********************************************************************
/*void init_crcccitt_tab( void ) {

	uint16 i;
	uint16 j;
	uint16 crc;
	uint16 c;

	for (i=0; i<256; i++) {

		crc = 0;
		c   = i << 8;

		for (j=0; j<8; j++) {

			if ( (crc ^ c) & 0x8000 )
                crc = ( crc << 1 ) ^ CRC_POLY_CCITT;
			else
                crc =   crc << 1;

			c = c << 1;
		}

		crc_tabccitt[i] = crc;
	}

	crc_tabccitt_init = 1;

}*/

//**********************************************************************
// Funo crc_ccitt_generic - calcula CRCCCITT
//
// Entradas - buffer com dados, quantida de bytes a calcular, valor para startup
// Sadas   - inteiro de 16bits com valor do CRC
//**********************************************************************
/*uint16 crc_ccitt_generic(byte *input_str, uint16 num_bytes, uint16 start_value)
{

	uint16 crc;
	uint16 tmp;
	uint16 short_c;
	uint16 a;
    byte *ptr;

	if (!crc_tabccitt_init)
        init_crcccitt_tab();

	crc = start_value;
	ptr = input_str;

	if (*ptr != '\0'){
        for (a=0; a<num_bytes; a++) {
            short_c = 0x00ff & (unsigned short) *ptr;
            tmp     = (crc >> 8) ^ short_c;
            crc     = (crc << 8) ^ crc_tabccitt[tmp];
            ptr++;
        }
    }
	return crc;

}*/

//********************************************************************************
// Funo para converter binrio para HEX (sada em formato ASCII)
//
// Obs.: Criar de modo global as varireis high_nibble, low_nibble,
//       high_char e low_char antes de usar esta funo!
//
// Entradas - valor a converter, dois ponteiros para retorno dos nibbles
// Sadas   - nenhuma, valores passados por referncia
//********************************************************************************
void bin_hex(byte binchar, byte *high_char, byte *low_char){

	byte high_nibble, low_nibble;

	high_nibble = (binchar & 0xF0) / 16;
	if(high_nibble > 0x09)
		*high_char = high_nibble + 0x37;
	else
		*high_char = high_nibble + 0x30;

	low_nibble = (binchar & 0x0F);

	if(low_nibble > 0x09)
		*low_char = low_nibble + 0x37;
	else
		*low_char = low_nibble + 0x30;

}

//********************************************************************************
// Funo para imprimir um valor em HEX (sada em formato ASCII)
//
//
// Entradas - valor a converter de HEX para ASCII, dois ponteiros para retorno dos nibbles
// Sadas   - nenhuma, valores passados por referncia
//********************************************************************************
void hex_to_ascii(byte hex_ascii, byte *high_char, byte *low_char){

	*high_char = (hex_ascii & 0xF0) >> 0x04;				//separa nibble msb
	if(*high_char <= 0x09)								//se menor que nove
		*high_char += 0x30;								//soma 30 H p/ converter ASCII (0 a 9)
	else{												// maior que nove
		*high_char -= 0x0A;								//tira dez
		*high_char += 0x41;								//soma 0x41 p/ converter ASCII (A a F)
	}

	*low_char = (hex_ascii & 0x0F);
														//separa nibble lsb
	if(*low_char <= 0x09)								//se menor que nove
		*low_char += 0x30;								//soma 30 H p/ converter ASCII (0 a 9)
	else{												// maior que nove
		*low_char -= 0x0A;								//tira dez
		*low_char += 0x41;								//soma 0x41 p/ converter ASCII (A a F)
	}

}




