/*
 * timerTIM1_STM.c
 *
 *  Created on: 25 de set de 2018
 *      Author: arne_
 */

//******************************************************************************
// Arquivos incluídos no módulo
//******************************************************************************
#include "timerTIM2_STM.h"

//*******************************************************************************
// Variáveis externas do módulo
//*******************************************************************************
extern volatile uint8_t time500ms;
extern volatile uint8_t LED_live;
extern volatile uint8_t mytimeout;
extern volatile uint8_t timeout_aut;
extern volatile uint8_t counter;
extern volatile uint8_t prima;
extern volatile uint8_t autoriza;

//*******************************************************************************
// Funções do módulo
//*******************************************************************************

//*******************************************************************************
// timerTIM1_init - inicia timer TIM2
//
// Update_event = TIM_CLK/[(PSC+1)x(ARR+1)x(RCR+10]
// PSC = 16 bits prescaler register
// ARR = 16/32 bits Auto reload
// RCR = 16 bits repetition counter
//
// Entradas - nenhuma
// Saídas   - nenhuma
//*******************************************************************************
void timerTIM2_init(uint8_t myint)
{
	TIM_TimeBaseInitTypeDef timerInitStructure;

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);

	//TIM_CLK            = 72MHz
	//Prescaler          = 36000 (16 bits)
	//Auto reload        = 500
	//Repetition counter = 0 (16 bits)

	//Update _event = 72E6/[(35999+1)*(499+1)*(0+1)] = 4Hz = 250ms

	timerInitStructure.TIM_Prescaler = 35999;
	timerInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
	timerInitStructure.TIM_Period = 499;
	timerInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
	timerInitStructure.TIM_RepetitionCounter = 0;
	TIM_TimeBaseInit(TIM2, &timerInitStructure);
	TIM_Cmd(TIM2, ENABLE);
	TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE);

    if(myint)
    	enable_timerTIM2_int();			//habilita int
}

//*******************************************************************************
// enable_timerTIM2_int - babilita int para timer TIM2
//
// Entradas - nenhuma
// Saídas   - nenhuma
//*******************************************************************************
void enable_timerTIM2_int(void)
{
    NVIC_InitTypeDef nvicStructure;
    nvicStructure.NVIC_IRQChannel = TIM2_IRQn;
    nvicStructure.NVIC_IRQChannelPreemptionPriority = 0;
    nvicStructure.NVIC_IRQChannelSubPriority = 1;
    nvicStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&nvicStructure);

}

//*******************************************************************************
// TIM2_int - atende int do timer tim2
//
// Entradas - nenhuma
// Saídas   - nenhuma
//*******************************************************************************
void TIM2_IRQHandler(void)
{
    if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET)
    {
        TIM_ClearITPendingBit(TIM2, TIM_IT_Update);

        if(timeout_aut){
        	mytimeout++;
        	if(mytimeout >= TIME2s){
        		mytimeout = 0;
        		timeout_aut = 0;
        		prima = 0;
        		counter = 0;
        		autoriza = 0;
        	}
        }

        time500ms++;
        if(time500ms >= TIMELED){
        	time500ms = 0;
        	if(!LED_live){
        		LED_live = 1;
        		setLED_Live;
        	}
        	else{
        		LED_live = 0;
        		resLED_Live;
         	}
        }
    }
}
